
Ryzom - Bug # 1157

Status: Closed Priority: Normal
Author: velogfx Category: OS: Mac
Created: 11/03/2010 Assignee: rti
Updated: 12/07/2011 Due date:
Subject: Missing Textures - Too many open files
Description

As you can see on the screen above, there are missing Textures on some models:

History
#1 - 11/03/2010 08:13 pm - velogfx

it's an random issue, after restarting the client some textures are back and other missing.

#2 - 06/06/2011 10:07 am - rti
- File Screen_shot_2011-06-06_at_10.01.12.jpg added
- File client.log added
- Status changed from New to Validated

indeed, seems very random. 
seeing this the first time in 7 month :(
#3 - 06/06/2011 10:10 am - rti

That explains it (from client.log):

2011/06/06 10:09:36 WRN 818417664 <Unknown> big_file.cpp 436 getFile : bnp: can't fopen big file
'/Users/rti/Code/ryzom-core/ryzom-core-repository/code/build-static-release/bin/ryzom_client.app/Contents/Resources/data/characters_maps_ma_hof_cheveux_hr.bnp' error 24 'Too many open files'

ma_hof_cheveux_hr.bnp' error 24 'Too many open files'

#4 - 06/06/2011 10:15 am - rti
- Subject changed from Mac - Alpha Build - Missing Textures to Missing Textures - Too many open files
- Category set to OS: Mac

#5 - 06/06/2011 11:42 pm - rti

I am currently observing that linking OpenAL soft (see #1314 for more information) makes this problem pop up on my machine. 
Client binaries linked with Apple's OpenAL.framework have no problem with open file limitations.

@velogfx: This ticket is quite old. Did you see this problem still in recent client builds? Does this problem occur with the newest OpenAL soft client
build?

#6 - 06/07/2011 10:12 am - kervala

So OpenAL crash could be related to files not being able to be opened ?

#7 - 06/07/2011 12:46 pm - rti

@kervala: Not sure. 
As velogfx confirmed, the file limit problem first occurred with the OpenAL soft build again. Long time before it was gone (probably due to #1003). On
the other hand, the two known OpenAL problems (#1116 and #1298) did not ocurre with the OpenAL soft build... :)

#8 - 06/07/2011 12:51 pm - velogfx

rti wrote:

I am currently observing that linking OpenAL soft (see #1314 for more information) makes this problem pop up on my machine. 
Client binaries linked with Apple's OpenAL.framework have no problem with open file limitations.

@velogfx: This ticket is quite old. Did you see this problem still in recent client builds? Does this problem occur with the newest OpenAL soft client
build?

hi, yes still get them in the latest OpenAL version.

#9 - 06/07/2011 12:53 pm - velogfx
- File Bildschirmfoto_2011-06-07_um_11.54.09.png added
here is the pic

#10 - 06/08/2011 02:53 am - rti

Ok. The problem really reoccured due to the linking of OpenAL soft.

Ace already fought a very similar problem month ago.
http://stackoverflow.com/questions/3166783/how-to-increase-the-limit-of-maximum-open-files-in-c-on-mac-os-x/3214064#3214064

Bottom line:
Calls to setrlimit (to increase the number of allowed file descriptors in a process) only work if the process did not call printf already.

Now, OpenAL soft is doing quite a lot of stuff at static initialization time (see Alc.c:471 alc_init(), __attribute__ ((constructor))). A part of this function
has the same effect as calling printf. setrlimit does not work anymore. Ryzom client is calling setrlimit later on, in main().

#11 - 06/09/2011 12:54 am - rti
- Status changed from Validated to Assigned
- Assignee set to rti
- Target version set to Version 0.9.0

BTW, this problem should only appear in WITH_STATIC_DRIVERS builds. Else, the OpenAL lib is loaded at a later point in time. So the problem
should be gone then.

Anyway, since this problem is strongly related to the usage of OpenAL soft on Mac OS X, i would like to mark this issue as resolved and track further
progress in Feature #1314 - OpenAL environment effects on Mac OS X.

Setting it on "assigned" now because redmine does not allow me to set it to "resolved" directly.

#12 - 06/09/2011 12:55 am - rti
- Status changed from Assigned to Resolved

#13 - 12/07/2011 02:50 pm - sfb
- Status changed from Resolved to Closed
